package com.terraformersmc.terrestria.block;

import com.terraformersmc.terraform.block.TerraformGrassBlock;
import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import java.util.Random;
import java.util.function.Supplier;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;

public class BasaltGrassBlock extends TerraformGrassBlock {
	public BasaltGrassBlock(class_2248 dirt, Supplier<class_2248> path, class_2251 settings) {
		super(dirt, path, settings);
	}

	@Override
	public void method_9652(class_1937 world, Random random, class_2338 centerPos, class_2680 grassState) {
		class_2338 above = centerPos.method_10084();

		class_2680 grass = TerrestriaBlocks.MONSTERAS.method_9564();
		class_2680 flower = TerrestriaBlocks.INDIAN_PAINTBRUSH.method_9564();

		// 33% chance of normal grass
		if(random.nextInt(3) == 0) {
			grass = class_2246.field_10479.method_9564();
		}

		outer:
		for(int tries = 0; tries < 128; tries++) {
			class_2338 pos = above;
			class_2680 block = random.nextInt(8) == 0 ? flower : grass;

			// Steps only a few blocks at a time in moving to the random position.
			// Likely to avoid growing on the other side of walls.
			for(int moves = 0; moves < 8; moves++) {
				pos = pos.method_10069(
					 random.nextInt(3) - 1,
					(random.nextInt(3) - 1) * random.nextInt(3) / 2,
					 random.nextInt(3) - 1
				);

				// Check if the block is a valid block
				if (!block.method_11591(world, pos) || world.method_8320(pos).method_21743(world, pos)) {
					continue outer;
				}
			}

			if (!world.method_8623(pos)) {
				continue;
			}

			if (block.method_11591(world, pos)) {
				world.method_8652(pos, block, 3);
			}
		}
	}
}
