package com.terraformersmc.terrestria.feature.trees;

import com.mojang.datafixers.Dynamic;
import com.terraformersmc.terrestria.feature.TreeDefinition;
import com.terraformersmc.terrestria.feature.trees.components.Roots;
import com.terraformersmc.terrestria.feature.trees.templates.ConiferTreeFeatureMega;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2525;
import net.minecraft.class_2944;
import net.minecraft.class_3111;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class RedwoodTreeFeatureMega extends ConiferTreeFeatureMega implements Roots {
	private TreeDefinition.Mega tree;

	public RedwoodTreeFeatureMega(Function<Dynamic<?>, ? extends class_3111> function, boolean notify, TreeDefinition.Mega tree) {
		super(function, notify, tree);
		this.tree = tree;
	}

	public void growRoots(Set<class_2338> blocks, class_3747 world, class_2338.class_2339 pos, int baseTrunkHeight, Random rand, class_3341 boundingBox) {
		int x = pos.method_10263();
		int y = pos.method_10264();
		int z = pos.method_10260();

		tryGrowRoot(blocks, world, pos.method_10103(x - 1, y, z + rand.nextInt(2)), baseTrunkHeight, rand, boundingBox);
		tryGrowRoot(blocks, world, pos.method_10103(x + 2, y, z + rand.nextInt(2)), baseTrunkHeight, rand, boundingBox);
		tryGrowRoot(blocks, world, pos.method_10103(x + rand.nextInt(2), y, z - 1), baseTrunkHeight, rand, boundingBox);
		tryGrowRoot(blocks, world, pos.method_10103(x + rand.nextInt(2), y, z + 2), baseTrunkHeight, rand, boundingBox);
	}

	public void tryGrowRoot(Set<class_2338> blocks, class_3747 world, class_2338.class_2339 bottom, int baseTrunkHeight, Random rand, class_3341 boundingBox) {
		if (rand.nextInt(5) == 0) {
			return;
		}

		int height = rand.nextInt(4) + 1;

		for (int i = 0; i < height; i++) {
			if (method_16432(world, bottom) || class_2944.method_16425(world, bottom) || world.method_16358(bottom, state -> state.method_11614() instanceof class_2525)) {
				method_12773(blocks, world, bottom, tree.getBark(), boundingBox);
			}

			bottom.method_10098(class_2350.field_11036);
		}
	}

	@Override
	public int getHeight(Random rand) {
		return rand.nextInt(16) + 32;
	}

	@Override
	public int getBareTrunkHeight(Random rand) {
		return 12 + rand.nextInt(8);
	}
}
