package com.terraformersmc.terrestria.init;

import com.terraformersmc.terrestria.Terrestria;
import com.terraformersmc.terrestria.biome.*;
import net.fabricmc.fabric.api.event.registry.RegistryEntryAddedCallback;
import net.minecraft.class_1959;
import net.minecraft.class_1972;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import java.util.function.Consumer;

public class TerrestriaBiomes {
	public static class_1959 CALDERA;
	public static class_1959 CALDERA_BEACH;
	public static class_1959 CALDERA_FOOTHILLS;
	public static class_1959 CALDERA_RIDGE;
	public static class_1959 CYPRESS_FOREST;
	public static class_1959 CYPRESS_SWAMP;
	public static class_1959 DENSE_WOODLANDS;
	public static class_1959 DENSE_WOODLANDS_EDGE;
	public static class_1959 HEMLOCK_CLEARING;
	public static class_1959 HEMLOCK_RAINFOREST;
	public static class_1959 JAPANESE_MAPLE_FOREST;
	public static class_1959 LUSH_REDWOOD_CLEARING;
	public static class_1959 LUSH_REDWOOD_FOREST;
	public static class_1959 LUSH_REDWOOD_FOREST_EDGE;
	public static class_1959 RAINBOW_RAINFOREST;
	public static class_1959 RAINBOW_RAINFOREST_LAKE;
	public static class_1959 RAINBOW_RAINFOREST_MOUNTAINS;
	public static class_1959 REDWOOD_CLEARING;
	public static class_1959 REDWOOD_FOREST;
	public static class_1959 REDWOOD_FOREST_EDGE;
	public static class_1959 SAKURA_FOREST;
	public static class_1959 SNOWY_HEMLOCK_CLEARING;
	public static class_1959 SNOWY_HEMLOCK_FOREST;
	public static class_1959 VOLCANIC_ISLAND;
	public static class_1959 VOLCANIC_ISLAND_BEACH;
	public static class_1959 VOLCANIC_ISLAND_SHORE;
	public static class_1959 WOODED_CYPRESS_HILLS;
	public static class_1959 WOODED_JAPANESE_MAPLE_HILLS;
	public static class_1959 WOODED_SAKURA_HILLS;

	public static void init() {

		CalderaBiomes.register();
		CypressForestBiomes.register();
		CypressSwampBiomes.register();
		DenseWoodlandsBiomes.register();
		HemlockRainforestBiomes.register();
		LushRedwoodForestBiomes.register();
		RainbowRainforestBiomes.register();
		RedwoodForestBiomes.register();
		SakuraForestBiomes.register();
		SnowyHemlockRainforestBiomes.register();
		JapaneseMapleForestBiomes.register();
		VolcanicIslandBiomes.register();

		TerrestriaFeatures.addVolcanoStarts(
				VOLCANIC_ISLAND,
				VOLCANIC_ISLAND_SHORE,
				class_1972.field_9446,
				class_1972.field_9470,
				class_1972.field_9439,
				class_1972.field_9448
		);

		forEveryBiome(TerrestriaFeatures::addVolcanoStructure);
	}

	public static <T extends class_1959> T register(String name, T biome) {
		return class_2378.method_10230(class_2378.field_11153, new class_2960(Terrestria.MOD_ID, name), biome);
	}

	private static void forEveryBiome(Consumer<class_1959> biomes) {
		class_2378.field_11153.forEach(biomes);
		RegistryEntryAddedCallback.event(class_2378.field_11153).register((rawId, id, biome) -> biomes.accept(biome));
	}
}
